#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#define MAX_N_CHARS 1000

FILE *stream;
FILE *stream2;

int find_word( char *s )
{
  char buffer[ MAX_N_CHARS + 1 ];
  
  // printf( "Looking for %s\n", s );

  for( ; ; )
    {
      if ( fscanf( stream, "%s", buffer ) < 1 )
	{
	  // printf( "No more input\n" );
	  return 0;
	}
      int value = strcmp( s, buffer );
      // printf( "Comparing %s %s %d\n", s, buffer, value );
      if ( value == 0 )
	return 1;
    }
}

int main( int argc, char *argv[] )
{
  char buffer[ MAX_N_CHARS + 1 ];
  long numbers[20];
  float fnumbers[20];
  char filename[ MAX_N_CHARS + 1 ];
  char filename2[ MAX_N_CHARS + 1 ];
  char directory[ MAX_N_CHARS + 1 ];
  char *line = NULL;
  size_t len = 0;
  ssize_t read;
  int ignore;
  float voltage;
  int voltage_raw;
  float angle_gain, angle_integral_gain, angle_velocity_gain;
    
  if ( argc != 2 )
    {
      fprintf( stderr, "Need a name argument: %s run33\n", argv[0] );
      exit( -1 );
    }
  sprintf( buffer, "mkdir %s\n", argv[1] );
  system( buffer );

  // stream = fopen( "putty.log", "r" );
  sprintf( directory, "%s.log", argv[1] );
  stream = fopen( directory, "r" );
  if ( stream == NULL )
    {
      fprintf( stderr, "NULL stream\n" );
      exit( -1 );
    }

  sprintf( filename2, "%s/files.txt", argv[1] );
  stream2 = fopen( filename2, "w" );
  if ( stream2 == NULL )
    {
      fprintf( stderr, "NULL stream2\n" );
      exit( -1 );
    }

  for ( int count = 0; ; count++ )
    {
      sprintf( filename, "%s/f%03d", argv[1], count );
      printf( "Writing %s\n", filename );

      if ( !find_word( "voltage" ) )
	break;
      fscanf( stream, "%g%d", &voltage, &voltage_raw );
      printf( "Voltage %g %d\n", voltage, voltage_raw );

      if ( !find_word( "Gains" ) )
	break;
      fscanf( stream, "%g%g%g", &angle_gain, &angle_integral_gain,
	      &angle_velocity_gain );
      printf( "Gains %g %g %g\n", angle_gain, angle_integral_gain,
	      angle_velocity_gain );

      if ( !find_word( "Data" ) )
	break;

      fprintf( stream2, "../%s %g %d %g %g %g ",
	       filename, voltage, voltage_raw,
	       angle_gain, angle_integral_gain, angle_velocity_gain );

      FILE *stream3 = fopen( filename, "w" );
      if ( stream3 == NULL )
	{
	  fprintf( stderr, "NULL stream\n" );
	  exit( -1 );
	}
      int i;
      for( i = 1; ; i++ )
	{
	  // printf( "i: %d\n", i );
	  int n_read = fscanf( stream, "%ld %ld %ld %g %g %g",
			       numbers, numbers+1, numbers+2,
			       fnumbers, fnumbers+1, fnumbers+2 );
	  if ( n_read != 6 )
	    break;
	  if ( numbers[0] < 1000000 )
	    break;
	  fprintf( stream3, "%ld %ld %d %ld %d %f %f %f %f\n",
		   numbers[0], numbers[1], 0, numbers[2], 0,
		   fnumbers[0], 0.0, fnumbers[1], fnumbers[2] );
	}
      printf( "%d points read.\n", i );
      fprintf( stream2, "%d\n", i );
      fclose( stream3 );
    }
  fclose( stream );
  fclose( stream2 );
}
